import { ArrayValues, Disposer, PartialObserver, Subscribable, Subscriber, Subscription, Unary } from './types.h';
declare class ObservableSubscription<T> implements Subscription {
    _disposer: Disposer | undefined;
    _observer: PartialObserver<T> | undefined;
    _closed: boolean;
    constructor(observer: PartialObserver<T>, source: Subscriber<T>);
    readonly closed: boolean;
    unsubscribe(): void;
}
export declare class Observable<T> implements Subscribable<T> {
    static of<TS extends any[]>(...args: TS): Observable<ArrayValues<TS>>;
    static from<A>(ish: Subscribable<A> | Observable<A> | Iterable<A>): Observable<A>;
    private _subscribe;
    constructor(_subscribe: Subscriber<T>);
    subscribe(next?: PartialObserver<T> | ((value: T) => void), error?: (reason: any) => void, complete?: () => void): ObservableSubscription<T>;
    pipe(): Observable<T>;
    pipe<A>(op1: Unary<Observable<T>, A>): A;
    pipe<A, B>(op1: Unary<Observable<T>, A>, op2: Unary<A, B>): B;
    pipe<A, B, C>(op1: Unary<Observable<T>, A>, op2: Unary<A, B>, op3: Unary<B, C>): C;
    pipe<A, B, C, D>(op1: Unary<Observable<T>, A>, op2: Unary<A, B>, op3: Unary<B, C>, op4: Unary<C, D>): D;
    pipe<A, B, C, D, E>(op1: Unary<Observable<T>, A>, op2: Unary<A, B>, op3: Unary<B, C>, op4: Unary<C, D>, op5: Unary<D, E>): E;
    pipe<A, B, C, D, E, F>(op1: Unary<Observable<T>, A>, op2: Unary<A, B>, op3: Unary<B, C>, op4: Unary<C, D>, op5: Unary<D, E>, op6: Unary<E, F>): F;
    pipe<A, B, C, D, E, F, G>(op1: Unary<Observable<T>, A>, op2: Unary<A, B>, op3: Unary<B, C>, op4: Unary<C, D>, op5: Unary<D, E>, op6: Unary<E, F>, op7: Unary<F, G>): G;
    pipe<A, B, C, D, E, F, G, H>(op1: Unary<Observable<T>, A>, op2: Unary<A, B>, op3: Unary<B, C>, op4: Unary<C, D>, op5: Unary<D, E>, op6: Unary<E, F>, op7: Unary<F, G>, op8: Unary<G, H>): H;
    pipe<A, B, C, D, E, F, G, H, I>(op1: Unary<Observable<T>, A>, op2: Unary<A, B>, op3: Unary<B, C>, op4: Unary<C, D>, op5: Unary<D, E>, op6: Unary<E, F>, op7: Unary<F, G>, op8: Unary<G, H>, op9: Unary<H, I>): I;
}
export {};
