import { getSpecies } from '../helpers/getSpecies';
export var catchError = function (fn, stream) {
    var C = getSpecies(stream);
    return new C(function (observer) {
        var subscription;
        subscription = stream.subscribe({
            start: function (s) {
                subscription = s;
            },
            next: function (value) {
                observer.next(value);
            },
            complete: function () {
                observer.complete();
            },
            error: function (reason) {
                subscription = fn(reason).subscribe({
                    start: function (s) {
                        subscription = s;
                    },
                    next: function (value) {
                        observer.next(value);
                    },
                    complete: function () {
                        observer.complete();
                    },
                    error: function (innerReason) {
                        observer.error(innerReason);
                    }
                });
            }
        });
        return function () { return subscription.unsubscribe(); };
    });
};
