import { getSpecies } from '../helpers/getSpecies';
var subscribe = function (streams, observer, onSubscribe) {
    return streams[0].subscribe({
        start: function (s) {
            onSubscribe(s);
        },
        next: function (value) {
            observer.next(value);
        },
        error: function (e) {
            observer.error(e);
        },
        complete: function () {
            if (streams.length > 1) {
                subscribe(streams.slice(1), observer, onSubscribe);
            }
            else {
                observer.complete();
            }
        }
    });
};
export function concat() {
    var streams = Array.prototype.slice.call(arguments);
    var C = getSpecies(streams[0]);
    return new C(function (observer) {
        var subscription;
        var onSubscribe = function (newSubscription) {
            subscription = newSubscription;
        };
        subscribe(streams, observer, onSubscribe);
        return function () {
            subscription.unsubscribe();
        };
    });
}
