import { debounce } from '../helpers/debounce';
import { getSpecies } from '../helpers/getSpecies';
export var debounceTime = function (dueTime, stream) {
    var C = getSpecies(stream);
    return new C(function (observer) {
        var lastValue;
        var lastEmitted = true;
        var debouncedNext = debounce(dueTime, function (value) {
            observer.next(value);
            lastEmitted = true;
        });
        return stream.subscribe({
            next: function (value) {
                lastValue = value;
                lastEmitted = false;
                debouncedNext(value);
            },
            error: function (e) {
                observer.error(e);
            },
            complete: function () {
                if (!lastEmitted) {
                    observer.next(lastValue);
                }
                observer.complete();
            }
        });
    });
};
