import { getSpecies } from '../helpers/getSpecies';
import { uniqueId } from '../helpers/uniqueId';
export var delay = function (wait, stream) {
    if (wait <= 0) {
        return stream;
    }
    var C = getSpecies(stream);
    return new C(function (observer) {
        var timers = {};
        var subscription;
        subscription = stream.subscribe({
            start: function (s) {
                subscription = s;
            },
            next: function (value) {
                var id = uniqueId();
                timers[id] = setTimeout(function () {
                    observer.next(value);
                    delete timers[id];
                }, wait);
            },
            error: function (reason) {
                observer.error(reason);
            },
            complete: function () {
                timers[uniqueId()] = setTimeout(function () {
                    observer.complete();
                }, wait);
            }
        });
        return function () {
            Object.keys(timers).forEach(function (timer) { return clearTimeout(+timer); });
            subscription.unsubscribe();
        };
    });
};
