// tslint:disable-next-line no-empty
var noop = function () { };
export var forEach = function (fn, stream) {
    if (fn === void 0) { fn = noop; }
    return new Promise(function (resolve, reject) {
        var i = 0;
        var subscription = stream.subscribe({
            next: function (value) {
                try {
                    fn(value, i);
                    i += 1;
                }
                catch (e) {
                    reject(e);
                    subscription.unsubscribe();
                }
            },
            error: reject,
            complete: resolve
        });
    });
};
