import { getSpecies } from '../helpers/getSpecies';
import { uniqueId } from '../helpers/uniqueId';
export var mergeAll = function (stream) {
    var C = getSpecies(stream);
    return new C(function (observer) {
        var rootCompleted = false;
        var rootSubscription;
        var subscriptions = {};
        rootSubscription = stream.subscribe({
            start: function (s) {
                rootSubscription = s;
            },
            next: function (inner) {
                var id = uniqueId();
                try {
                    subscriptions[id] = C.from(inner).subscribe({
                        start: function (s) {
                            subscriptions[id] = s;
                        },
                        next: function (value) {
                            observer.next(value);
                        },
                        error: function (reason) {
                            observer.error(reason);
                        },
                        complete: function () {
                            delete subscriptions[id];
                            if (rootCompleted && Object.keys(subscriptions).length === 0) {
                                observer.complete();
                            }
                        }
                    });
                }
                catch (err) {
                    observer.error(err);
                }
            },
            error: function (reason) {
                observer.error(reason);
            },
            complete: function () {
                rootCompleted = true;
                if (Object.keys(subscriptions).length === 0) {
                    observer.complete();
                }
            }
        });
        return function () {
            rootSubscription.unsubscribe();
            Object.keys(subscriptions).forEach(function (id) {
                subscriptions[id].unsubscribe();
            });
        };
    });
};
