import { transform } from '../helpers/transform';
var pairwiseFn = function () {
    var hasEmit = false;
    var lastValue;
    return function (observer, value) {
        if (hasEmit) {
            observer.next([lastValue, value]);
        }
        hasEmit = true;
        lastValue = value;
    };
};
export var pairwise = function (stream) {
    return transform(stream, pairwiseFn());
};
