import { transform } from '../helpers/transform';
var skipLastFn = function (count) {
    var values = new Array(count);
    return function (observer, value, index) {
        if (index < count) {
            values[index] = value;
        }
        else {
            var currentIndex = index % count;
            var oldValue = values[currentIndex];
            values[currentIndex] = value;
            observer.next(oldValue);
        }
    };
};
export var skipLast = function (count, stream) {
    if (count < 1) {
        return stream;
    }
    return transform(stream, skipLastFn(count));
};
