import { transform } from '../helpers/transform';
var defaultEquals = function (a, b) { return a === b; };
var skip = function (equals) {
    var init = true;
    var oldValue;
    return function (observer, value, index) {
        if (init) {
            init = false;
            oldValue = value;
            observer.next(value);
            return;
        }
        if (equals(oldValue, value, index)) {
            return;
        }
        oldValue = value;
        observer.next(value);
    };
};
export var skipRepeats = function (equals, stream) {
    if (equals === void 0) { equals = defaultEquals; }
    return transform(stream, skip(equals));
};
