import { getSpecies } from '../helpers/getSpecies';
export var takeLast = function (count, stream) {
    var C = getSpecies(stream);
    return new C(function (observer) {
        var values = [];
        return stream.subscribe({
            next: function (value) {
                values.push(value);
                if (values.length > count) {
                    values.shift();
                }
            },
            error: function (reason) {
                observer.error(reason);
            },
            complete: function () {
                for (var _i = 0, values_1 = values; _i < values_1.length; _i++) {
                    var value = values_1[_i];
                    observer.next(value);
                }
                observer.complete();
            }
        });
    });
};
