import { getSpecies } from '../helpers/getSpecies';
export var takeUntil = function (signal, stream) {
    var C = getSpecies(stream);
    return new C(function (observer) {
        var signalSubscription = signal.subscribe({
            next: function () {
                observer.complete();
            },
            error: function (reason) {
                observer.error(reason);
            }
        });
        if (observer.closed) {
            return undefined;
        }
        var streamSubscription = stream.subscribe(observer);
        return function () {
            streamSubscription.unsubscribe();
            signalSubscription.unsubscribe();
        };
    });
};
