"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FakeEventEmitter = /** @class */ (function () {
    function FakeEventEmitter() {
        var _this = this;
        this.addListener = jest.fn(function (event, handler) {
            _this.event = event;
            _this.handler = handler;
        });
        this.removeListener = jest.fn(function () {
            _this.event = undefined;
            _this.handler = undefined;
        });
    }
    FakeEventEmitter.prototype.emit = function () {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        if (this.handler) {
            this.handler.apply(this, values);
        }
    };
    return FakeEventEmitter;
}());
exports.FakeEventEmitter = FakeEventEmitter;
//# sourceMappingURL=fakeEventEmitter.js.map