"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var getSpecies_1 = require("../helpers/getSpecies");
var subject_1 = require("./subject");
exports.groupBy = function (selector, stream) {
    var C = getSpecies_1.getSpecies(stream);
    return new C(function (observer) {
        var groups = new Map();
        return stream.subscribe({
            error: function (reason) {
                observer.error(reason);
            },
            complete: function () {
                groups.forEach(function (_a) {
                    var _ = _a[0], sink = _a[1];
                    return sink.complete();
                });
                observer.complete();
            },
            next: function (value) {
                var key = selector(value);
                var subject;
                if (groups.has(key)) {
                    subject = groups.get(key); // WTF TS
                }
                else {
                    subject = subject_1.createSubject();
                    observer.next(subject[0]);
                    groups.set(key, subject);
                }
                subject[1].next(value);
            }
        });
    });
};
//# sourceMappingURL=groupBy.js.map