"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var timers_1 = require("timers");
var Observable_1 = require("../core/Observable");
exports.interval = function (period) {
    return new Observable_1.Observable(function (observer) {
        var i = 0;
        var intervalId = setInterval(function () {
            observer.next(i++);
        }, period);
        return function () { return timers_1.clearInterval(intervalId); };
    });
};
//# sourceMappingURL=interval.js.map