"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var transform_1 = require("../helpers/transform");
var pairwiseFn = function () {
    var hasEmit = false;
    var lastValue;
    return function (observer, value) {
        if (hasEmit) {
            observer.next([lastValue, value]);
        }
        hasEmit = true;
        lastValue = value;
    };
};
exports.pairwise = function (stream) {
    return transform_1.transform(stream, pairwiseFn());
};
//# sourceMappingURL=pairwise.js.map