"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var getSpecies_1 = require("../helpers/getSpecies");
exports.sample = function (signal, stream) {
    var C = getSpecies_1.getSpecies(stream);
    return new C(function (observer) {
        var streamEmitted = false;
        var lastResult;
        var streamSubscription = stream.subscribe({
            next: function (value) {
                streamEmitted = true;
                lastResult = value;
            },
            error: function (reason) {
                observer.error(reason);
            },
            complete: function () {
                observer.complete();
            }
        });
        var signalSubscription = signal.subscribe({
            next: function () {
                if (streamEmitted) {
                    observer.next(lastResult);
                    streamEmitted = false;
                }
            },
            error: function (reason) {
                observer.error(reason);
            },
            complete: function () {
                observer.complete();
            }
        });
        return function () {
            streamSubscription.unsubscribe();
            signalSubscription.unsubscribe();
        };
    });
};
//# sourceMappingURL=sample.js.map