"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var transform_1 = require("../helpers/transform");
var skipLastFn = function (count) {
    var values = new Array(count);
    return function (observer, value, index) {
        if (index < count) {
            values[index] = value;
        }
        else {
            var currentIndex = index % count;
            var oldValue = values[currentIndex];
            values[currentIndex] = value;
            observer.next(oldValue);
        }
    };
};
exports.skipLast = function (count, stream) {
    if (count < 1) {
        return stream;
    }
    return transform_1.transform(stream, skipLastFn(count));
};
//# sourceMappingURL=skipLast.js.map