"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var getSpecies_1 = require("../helpers/getSpecies");
exports.takeUntil = function (signal, stream) {
    var C = getSpecies_1.getSpecies(stream);
    return new C(function (observer) {
        var signalSubscription = signal.subscribe({
            next: function () {
                observer.complete();
            },
            error: function (reason) {
                observer.error(reason);
            }
        });
        if (observer.closed) {
            return undefined;
        }
        var streamSubscription = stream.subscribe(observer);
        return function () {
            streamSubscription.unsubscribe();
            signalSubscription.unsubscribe();
        };
    });
};
//# sourceMappingURL=takeUntil.js.map