"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var getSpecies_1 = require("../helpers/getSpecies");
exports.timeout = function (time, stream) {
    var C = getSpecies_1.getSpecies(stream);
    return new C(function (observer) {
        var timer = setTimeout(function () {
            observer.error(new Error('Timeout has occurred'));
        }, time);
        return stream.subscribe({
            next: function (value) {
                observer.next(value);
                if (timer) {
                    clearTimeout(timer);
                    timer = null;
                }
            },
            error: function (reason) {
                observer.error(reason);
                clearTimeout(timer);
                timer = null;
            },
            complete: function () {
                observer.complete();
                clearTimeout(timer);
                timer = null;
            }
        });
    });
};
//# sourceMappingURL=timeout.js.map